var zip="33037";
var xmlData=null;
var units="english";
var wxview1="calendar";
var wxview2="hourly";
var showpop = false;
var showGtemps = true;
var timerInterval = 150000; // updates every 2.5 minutes
var timer = null;
var wxstate = 4;

function startwidget() 
{
	if (window.widget)
	{
		
		// The preferences are retrieved:
		zip = widget.preferenceForKey(makeKey("zip"));
		units = widget.preferenceForKey(makeKey("units"));
		wxview1 = widget.preferenceForKey(makeKey("wxview1"));
		wxview2 = widget.preferenceForKey(makeKey("wxview2"));
		wxstate = widget.preferenceForKey(makeKey("wxstate"));

		if (!zip)
			zip = "33037";
		
		if (!units)
			units = "english";
		
		if (!wxview1)
			wxview1 = "radar";
		
		if (!wxview2)
			wxview2 = "hourly";
			
		if (!wxstate)
			wxstate = 1;
		
		document.getElementById("radarimg").src = 'images/radarHolder.png';
		
		if (wxview1 == "calendar")
		{
			document.getElementById("viewradar").style.display = "none";
			document.getElementById("iconradar").style.display = "block";
			document.getElementById("viewcalendar").style.display = "block";
			document.getElementById("iconcalendar").style.display = "none";
		}
		else
		{
			document.getElementById("viewradar").style.display = "block";
			document.getElementById("iconradar").style.display = "none";
			document.getElementById("viewcalendar").style.display = "none";
			document.getElementById("iconcalendar").style.display = "block";
		}
		
		if (wxview2 == "hourly")
		{
			document.getElementById("viewhourly").style.display = "block";
			document.getElementById("iconhourly").style.display = "none";
			document.getElementById("viewforecast").style.display = "none";
			document.getElementById("iconforecast").style.display = "block";
		}
		else
		{
			document.getElementById("viewhourly").style.display = "none";
			document.getElementById("iconhourly").style.display = "block";
			document.getElementById("viewforecast").style.display = "block";
			document.getElementById("iconforecast").style.display = "none";
		}
		
		
		switch(wxstate)
		{
			case 2:
				document.getElementById("section2").style.display = "block";
				document.getElementById("section3").style.display = "none";
				document.getElementById("section4").style.top = "253px";
				break;
			case 3:
				document.getElementById("section2").style.display = "bock";
				document.getElementById("section3").style.display = "block";
				document.getElementById("section3").style.top = "253px";
				document.getElementById("section4").style.display = "block";
				document.getElementById("section4").style.top = "345px";
				break;
			case 4:
				document.getElementById("section2").style.display = "none";
				document.getElementById("section3").style.display = "block";
				document.getElementById("section3").style.top = "68px";
				document.getElementById("section4").style.top = "160px";
				break;
			case 1:
				document.getElementById("section2").style.display = "none";
				document.getElementById("section3").style.display = "none";
				document.getElementById("section4").style.top = "68px";
				document.getElementById("section4").style.display = "block";
				break;
		   
		   
		}
		
		
		retrieveWeather();
		timer = setInterval ('retrieveWeather();', timerInterval);
	}
}

function doload()
{
	if (window.widget)
	{	
		document.getElementById("radarimg").src = 'images/radarHolder.png';
		retrieveWeather();
		timer = setInterval ('retrieveWeather();', timerInterval);
	}
}


function blankfunction()
{
	
}

function togglewxview1()
{
	if (wxview1 == "radar")
	{
		document.getElementById("viewradar").style.display = "none";
		document.getElementById("iconradar").style.display = "block";
		document.getElementById("viewcalendar").style.display = "block";
		document.getElementById("iconcalendar").style.display = "none";
		wxview1 = "calendar";
	}
	else
	{
		document.getElementById("viewradar").style.display = "block";
		document.getElementById("iconradar").style.display = "none";
		document.getElementById("viewcalendar").style.display = "none";
		document.getElementById("iconcalendar").style.display = "block";
		wxview1 = "radar";	
	}
	widget.setPreferenceForKey(wxview1,makeKey("wxview1"));
	
	//if it's closed, open it
	if (wxstate == 1)
	{
		togglestates();
	}
	else if (wxstate == 4)
	{
		wxstate = 2;
		togglestates();
	}
}

function togglewxview2()
{
	if (wxview2 == "forecast")
	{
		document.getElementById("viewhourly").style.display = "block";
		document.getElementById("iconhourly").style.display = "none";
		document.getElementById("viewforecast").style.display = "none";
		document.getElementById("iconforecast").style.display = "block";
		wxview2 = "hourly";
	}
	else
	{
		document.getElementById("viewhourly").style.display = "none";
		document.getElementById("iconhourly").style.display = "block";
		document.getElementById("viewforecast").style.display = "block";
		document.getElementById("iconforecast").style.display = "none";
		wxview2 = "forecast";	
	}
	widget.setPreferenceForKey(wxview2,makeKey("wxview2"));
	
	//if it's closed, open it
	if (wxstate == 2)
	{
		togglestates();
	}
	else if (wxstate == 1)
	{
		wxstate = 3;
		togglestates();
	}
}

function togglestates()
{
	
	switch(wxstate)
	{
		case 1:
			document.getElementById("section2").style.display = "block";
			document.getElementById("section3").style.display = "none";
			
			//footer treatment
			document.getElementById("section4").style.top = "253px";
			wxstate = 2;
			break;
		case 2:
			document.getElementById("section2").style.display = "bock";
			document.getElementById("section3").style.display = "block";
			document.getElementById("section3").style.top = "253px";
			
			//footer treatment
			document.getElementById("section4").style.display = "block";
			document.getElementById("section4").style.top = "345px";
			wxstate = 3;
			break;
	    case 3:
			document.getElementById("section2").style.display = "none";
			document.getElementById("section3").style.display = "block";
			document.getElementById("section3").style.top = "68px";
			
			//footer treatment
			document.getElementById("section4").style.top = "160px";
			wxstate = 4;
			break;
	    case 4:
			document.getElementById("section2").style.display = "none";
			document.getElementById("section3").style.display = "none";
			
			//footer treatment
			document.getElementById("section4").style.top = "68px";
			document.getElementById("section4").style.display = "block";
			wxstate = 1;
			break;
	   
	   
	}
	widget.setPreferenceForKey(wxstate,makeKey("wxstate"));
}

function selectLocation()
{
	var box = document.getElementById("zipmenu");
	if (box.options.length > 0)
	{
		if (box.options[box.selectedIndex] != null)
		{
			var selected = box.options[box.selectedIndex].value;
			if (selected != null && selected != '')
			{
				zip = selected;
				widget.setPreferenceForKey(selected,makeKey("zip"));
			}
		}
	}
	
	
	var ubox = document.getElementById("unitbox");
	if (ubox.options[ubox.selectedIndex] != null)
	{
		units = ubox.options[ubox.selectedIndex].value;
		widget.setPreferenceForKey(units,makeKey("units"));
	}
	doload();
	hidePrefs();
}


function goToUrl(url)
{
	if (window.widget)
	{
		widget.openURL(url);
	}
}

function makeSearchList()
{
	var term = document.getElementById("zipbox").value;
	var scity;
	var sstate;
	var szip;
	if (term != "" && term != null)
	{
		loadLocations(term);
		if (searchComplete)
		{
			var locationSelectBox = document.getElementById("zipmenu");
			var len = CurrentSearch.SearchArray.length;
			
			locationSelectBox.options.length = 0;
			if (len > 0)
			{
				for (var i=0;i<len;++i)
				{
					scity = CurrentSearch.SearchArray[i].city;
					sstate = CurrentSearch.SearchArray[i].state;
					szip = CurrentSearch.SearchArray[i].zip
					locationSelectBox.options[i] = new Option(scity  + ', ' + sstate , szip);
				}
			}
			else
			{
				locationSelectBox.options[0] = new Option("No Matches Found", null);
			}
		}
	}
}



function showDataError()
{
	document.getElementById("error").style.display = "bock";
}

function retrieveWeather() 
{
	if (window.widget)
	{
		document.getElementById("error").style.display = "none";
		loadData(units);
		if (DataComplete) 
		{
			
			
			//sponsor
			if (CurrentSponsor.fontText != "")
			{
				document.getElementById("sponsorfront").innerHTML = CurrentSponsor.fontText;
			}
			
			if (CurrentSponsor.backAsset != "")
			{
				document.getElementById("sponsorback").innerHTML = CurrentSponsor.backAsset;
			}
			
			
			if (CurrentLocation.intl == "1")
			{
				showpop = false;
			}
			
			//radar
			document.getElementById("radarimg").src = 'images/radarHolder.png';
			document.getElementById("radarimg").src = CurrentImages.radar;
			document.getElementById("radarmap").innerHTML = CurrentImages.imagemap;
			document.getElementById("radarenlarge").setAttribute('onclick','goToUrl(CurrentConditions.radarUrl)');
			
			
			
			
			//check for severe weather
			document.getElementById("severebanner").style.display = "none";
			if (CurrentWatches.isactive == "1")
			{
				document.getElementById("severebanner").style.display = "block";
				document.getElementById("severebanner").setAttribute('onclick','goToUrl(CurrentWatches.url)');
			}
			
			
			//place the city name
			if (CurrentLocation.city.length>20) {
				document.getElementById("cityname").innerHTML = CurrentLocation.city.substr(0,19) + "...";
			} else {
				document.getElementById("cityname").innerHTML = CurrentLocation.city;
			}
			
			if (CurrentConditions.text.length < 18)
			{
				document.getElementById("curdate").innerHTML = CurrentConditions.text + " at " + CurrentLocation.time;
			}
			else
			{
				document.getElementById("curdate").innerHTML = CurrentConditions.text
			}
			
			
			document.getElementById("cityname").setAttribute('onclick','goToUrl(CurrentForecasts.url)');
			document.getElementById("currenticon").setAttribute('onclick','goToUrl(CurrentForecasts.url)');
			document.getElementById("curdate").setAttribute('onclick','goToUrl(CurrentForecasts.url)');
			document.getElementById("currenttemp").setAttribute('onclick','goToUrl(CurrentForecasts.url)');
			
			//current
			//position the temp below the icon
			var ctpos = "-30px";
			switch (CurrentConditions.icon)
			{
				case "01":
				case "02":
				case "03":
				case "04":
				case "05":
				case "06":
				case "07":
				case "08":
				case "33":
				case "34":
				case "35":
				case "36":
				case "37":
				case "38":
					ctpos = "-17px";
					break;
			}
			
			document.getElementById("currenticon").style.top = ctpos;
			document.getElementById("currenttemp").innerHTML = CurrentConditions.temperature + '&deg;'; //temps
			var icon = document.getElementById("curi");
			icon.src = "images/wxicons/" + CurrentConditions.icon + ".png";
			
			//hourly
			var hourlen = 5;
			if (showpop)
				hourlen = 4;
			for (var i=0; i<hourlen; ++i)
			{
				document.getElementById("h"+i).setAttribute('onclick','goToUrl(CurrentConditions.hourlyURL)');
				document.getElementById("h"+i+"0").innerHTML = CurrentHourly.hourlyArray[i].time; //time
				document.getElementById("h"+i+"1").innerHTML = CurrentHourly.hourlyArray[i].temp + '&deg;'; //temps
				document.getElementById("h"+i+"2").style.backgroundColor = CurrentHourly.hourlyArray[i].tcolor;
				document.getElementById("h"+i+"3").style.backgroundColor = CurrentHourly.hourlyArray[i].color;
				var icon = document.getElementById("h"+i+"4i");
				icon.src = "images/wxicons/" + CurrentHourly.hourlyArray[i].icon + ".png";
			}
			
			//accupop
			if (showpop)
			{
				document.getElementById("h4").style.display = "none";
				document.getElementById("pop3").style.backgroundColor = CurrentHourly.hourlyArray[3].tcolor;
				document.getElementById("pop1").innerHTML = "Precip";
				document.getElementById("pop2").innerHTML = CurrentPop.pct + "%";
				document.getElementById("pop5").innerHTML = CurrentPop.type;
				switch (CurrentPop.type)
				{
					case "SNOW":document.getElementById("pop4").style.backgroundColor = "#22559D";break;
					case "ICE":document.getElementById("pop4").style.backgroundColor = "#F9818F";break;
					case "RAIN":document.getElementById("pop4").style.backgroundColor = "#73BE1E";break;
				}
				document.getElementById("accupop").style.display = "block";
				
			}
			
			//4-day forecast
			for (var i=0; i<4; ++i)
			{
				var tday;
				switch (CurrentForecasts.forecastArray[i].weekDay)
				{
					case "Sun":tday="Sunday"; break;
					case "Mon":tday="Monday"; break;	
					case "Tue":tday="Tuesday"; break;	
					case "Wed":tday="Wednesday"; break;	
					case "Thu":tday="Thursday"; break;	
					case "Fri":tday="Friday"; break;	
					case "Sat":tday="Saturday"; break;	
				}
				document.getElementById("f"+i).setAttribute('onclick','goToUrl(CurrentForecasts.forecastArray['+i+'].url)');
				document.getElementById("f"+i+"0").innerHTML = CurrentForecasts.forecastArray[i].weekDay; 
				document.getElementById("f"+i+"1").innerHTML = CurrentForecasts.forecastArray[i].daytimeHigh + '&deg;' + '/&nbsp;'; //temps
				document.getElementById("f"+i+"2").innerHTML = CurrentForecasts.forecastArray[i].nighttimeLow + '&deg;'; //temps
				document.getElementById("f"+i+"3").style.backgroundColor = "#1799C4";
				document.getElementById("f"+i+"4").style.backgroundColor = CurrentForecasts.forecastArray[i].daytimeColor;
				var icon = document.getElementById("f"+i+"5i");
				icon.src = "images/wxicons/" + CurrentForecasts.forecastArray[i].daytimeIcon + ".png";
			}
			
			//calendar
			//label the month
			var monthlabel = CurrentForecasts.forecastArray[0].month
			for (var i=1; i<15; ++i)
			{
				if (CurrentForecasts.forecastArray[i].month != monthlabel)
				{
					monthlabel = monthlabel + " / " + CurrentForecasts.forecastArray[i].month;
					break;
				}
			}
			document.getElementById("calmonth").innerHTML = monthlabel;
			var calstart = CurrentForecasts.forecastArray[0].weekDay; 
			switch (calstart) {
				case "Mon" : calstart=2;break;
				case "Tue" : calstart=3;break;
				case "Wed" : calstart=4;break;
				case "Thu" : calstart=5;break;
				case "Fri" : calstart=6;break;
				case "Sat" : calstart=7;break;
				case "Sun" : calstart=1;break;
			}
			
			//clean the calendar
			for (var i=1;i<22;++i)
			{
				document.getElementById("calcell" + i).style.backgroundColor = '#bfbfbf';
				document.getElementById("cd"+i).innerHTML = '';
				document.getElementById("ct"+i).innerHTML = '';
			}
			
			var len = calstart + 15;
			var j=0;
			for (var i=calstart; i<len; ++i)
			{
				document.getElementById("calcell" + i).style.backgroundColor = CurrentForecasts.forecastArray[j].daytimeColor;
				document.getElementById("cd"+i).innerHTML = CurrentForecasts.forecastArray[j].wxdate;
				if (showGtemps)
				{
					document.getElementById("ct"+i).innerHTML = CurrentForecasts.forecastArray[j].daytimeGTemp + '<span class="s">s</span>';
				}
				else
				{
					document.getElementById("ct"+i).innerHTML = CurrentForecasts.forecastArray[j].daytimeHigh + '&deg;';
				}
				//document.getElementById("ct" + i).setAttribute('onclick','goToUrl(CurrentForecasts.forecastArray['+j+'].url)');
				j=j+1;
			}
			document.getElementById("viewcalendar").setAttribute('onclick','goToUrl(CurrentForecasts.url15)');
		} 
		else 
		{
			showDataError();
		}
	}
}


/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	//var front = document.getElementById("viewradar");
	//var back = document.getElementById("viewcalendar");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}


function makeKey(key)
{
	return (widget.identifier + "_" + key);
}



/***************/
// WIDGET EVENTS
/***************/

// removed is called when the widget is removed from the Dashboard

function removed()
{

	widget.setPreferenceForKey(null,makeKey("zip"));
	widget.setPreferenceForKey(null,makeKey("units"));
	widget.setPreferenceForKey(null,makeKey("wxview1"));
	widget.setPreferenceForKey(null,makeKey("wxview2"));
	widget.setPreferenceForKey(null,makeKey("wxstate"));
}

// focused is called when the widget gets key focus

function focused()
{
	document.getElementById('worldText').style.color = 'white'; 
}

// blurred is called when the widget looses key focus

function blurred()
{
	document.getElementById('worldText').style.color = 'gray'; 
}

function onhide () 
{
	document.getElementById("radarimg").src = 'images/radarHolder.png';
	if (timer != null) {
		// we were hidden, clear the timer
		clearInterval(timer);
		timer = null;
	}
}

function onshow () 
{
	//doload();
	startwidget();
}


// Here we register for some widget events

if(window.widget)
{
	widget.onremove = removed;
	widget.onshow = onshow;
	widget.onhide = onhide;
	window.onfocus = focused;
	window.onblur = blurred;
}	


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}