var WeatherUnits;
var CurrentLocation;
var CurrentConditions;
var CurrentImages;
var CurrentForecasts;
var CurrentWatches;
var CurrentPop;
var CurrentHourly;
var CurrentLinks;
var CurrentSponsor;
var CurrentSearch;
var ErrorString="";
var DataComplete=false;
var searchComplete = false;
var url = "http://apple.accuweather.com/widget/osx1/";

	
if (window.timerInterval != 150000)
	window.timerInterval = 150000; // 2.5 minutes
	
	

function Images(xmlNode) 
{
	this.radar=xmlNode.getElementsByTagName('radar').item(0).firstChild.data;
	this.imagemap=xmlNode.getElementsByTagName('imagemap').item(0).firstChild.data;
}

function Units(xmlNode) 
{
	this.tempUnit=xmlNode.getAttribute('temp');
	this.speedUnit=xmlNode.getAttribute('speed');
	this.distUnit=xmlNode.getAttribute('dist');
	this.presUnit=xmlNode.getAttribute('pres');
	this.precUnit=xmlNode.getAttribute('prec');
}

function Watches(xmlNode) 
{
	this.zone=xmlNode.getAttribute('zone');
	this.county=xmlNode.getAttribute('county');
	this.isactive=xmlNode.getAttribute('isactive');
	if (xmlNode.getElementsByTagName('url').item(0).firstChild!=null) {
		this.url=xmlNode.getElementsByTagName('url').item(0).firstChild.data;
	} else {
		this.url="";
	}
}

function Location(xmlNode) 
{
	this.city=xmlNode.getAttribute('city');
	this.state=xmlNode.getAttribute('state');
	this.wxdate=xmlNode.getAttribute('wxdate');
	this.intl=xmlNode.getAttribute('intl');
	this.time = xmlNode.getAttribute('time');
}

function Sponsor(xmlNode) 
{
	if (xmlNode.getElementsByTagName('front_text').item(0).firstChild != null)
	{
		this.fontText=xmlNode.getElementsByTagName('front_text').item(0).firstChild.data;
	}
	else
	{
		this.fontText="";
	}
	
	if (xmlNode.getElementsByTagName('back_asset').item(0).firstChild != null)
	{
		this.backAsset=xmlNode.getElementsByTagName('back_asset').item(0).firstChild.data;
	}
	else
	{
		this.backAsset="";
	}
	
	if (xmlNode.getElementsByTagName('click_url').item(0).firstChild != null)
	{
		this.clickUrl=xmlNode.getElementsByTagName('click_url').item(0).firstChild.data;
	}
	else
	{
		this.clickUrl="";
	}		
}


function AccuPop(xmlNode) 
{
	tempNode=xmlNode.getElementsByTagName('pop').item(0);
	this.type=tempNode.getAttribute('type');
	this.pct=tempNode.getAttribute('pct');
}


function Conditions(xmlNode) 
{
	this.url=xmlNode.getElementsByTagName('url').item(0).firstChild.data;
	tempNode=xmlNode.getElementsByTagName('wxc').item(0);
	this.temperature=tempNode.getAttribute('temp');
	this.realFeel=tempNode.getAttribute('rft');
	this.humidity=tempNode.getAttribute('hum');
	this.color=tempNode.getAttribute('color');
	this.tcolor=tempNode.getAttribute('tcolor');
	this.text=tempNode.getAttribute('text');
	this.icon=tempNode.getAttribute('icon');
	this.windGust=tempNode.getAttribute('wgus');
	this.windSpeed=tempNode.getAttribute('wspd');
	this.windDir=tempNode.getAttribute('wdir');
	this.visibility=tempNode.getAttribute('vis');
	this.precip=tempNode.getAttribute('prec');
	this.uvindex=tempNode.getAttribute('uvi');
	this.uvtext=tempNode.getAttribute('uvt');
	this.radarUrl=xmlNode.getElementsByTagName('radurl').item(0).firstChild.data;
	this.hourlyURL=xmlNode.getElementsByTagName('hourlyurl').item(0).firstChild.data;
}

function Links(xmlNode) 
{
	this.promo1Link=xmlNode.getElementsByTagName('promo1').item(0).getAttribute('url');
	this.promo1Name=xmlNode.getElementsByTagName('promo1').item(0).getAttribute('name');
	//this.homeLink=xmlNode.getElementsByTagName('home').item(0).getAttribute('url');
	this.homeLink="http://www.accuweather.com";
}

function Hourly(xmlNode) 
{
	tempNodes=xmlNode.getElementsByTagName('hour');
	tempArray=new Array(tempNodes.length);
	for (count=0;count<tempNodes.length;count++) {
		tempArray[count]=new HourlyHour(tempNodes[count]);
	}
	this.hourlyArray=tempArray;
}

function HourlyHour(xmlNode)
{
	this.hour=xmlNode.getAttribute('number');
	this.time=xmlNode.getAttribute('time');
	this.temp=xmlNode.getAttribute('temp');
	this.icon=xmlNode.getAttribute('icon');
	this.color=xmlNode.getAttribute('color');
	this.tcolor=xmlNode.getAttribute('tcolor');
}

function Search(xmlNode)
{
	tempNodes=xmlNode.getElementsByTagName('location');
	tempArray=new Array(tempNodes.length);
	for (count=0;count<tempNodes.length;count++) {
		tempArray[count]=new SearchResult(tempNodes[count]);
	}
	this.SearchArray=tempArray;
}

function SearchResult(xmlNode)
{
	this.city = xmlNode.getAttribute('city');
	this.state = xmlNode.getAttribute('state');
	this.zip = xmlNode.getAttribute('location');
}


function Forecasts(xmlNode) 
{
	this.url=xmlNode.getElementsByTagName('url').item(0).firstChild.data;
	this.url15=xmlNode.getElementsByTagName('url15').item(0).firstChild.data;
	tempNodes=xmlNode.getElementsByTagName('day');
	tempArray=new Array(tempNodes.length);
	for (count=0;count<tempNodes.length;count++) {
		tempArray[count]=new ForecastDay(tempNodes[count]);
	}
	this.forecastArray=tempArray;
}

function ForecastDay(xmlNode) 
{
	this.dayNumber=xmlNode.getAttribute('number');
	this.wxdate=xmlNode.getAttribute('wxdate');
	this.date=xmlNode.getAttribute('date');
	this.month=xmlNode.getAttribute('month');
	this.weekDay=xmlNode.getAttribute('wday');
	switch (this.weekDay) {
		case "Monday" : this.shortWeekDay="Mon";break;
		case "Tuesday" : this.shortWeekDay="Tue";break;
		case "Wednesday" : this.shortWeekDay="Wed";break;
		case "Thursday" : this.shortWeekDay="Thu";break;
		case "Friday" : this.shortWeekDay="Fri";break;
		case "Saturday" : this.shortWeekDay="Sat";break;
		case "Sunday" : this.shortWeekDay="Sun";break;
	}
	this.url=xmlNode.getElementsByTagName('url').item(0).firstChild.data;
	
	//Daytime forecast data
	//this.daytimeTextShort=xmlNode.getElementsByTagName('./daytime/txtshort').item(0).firstChild.data;
	//this.daytimeTextLong=xmlNode.getElementsByTagName('./daytime/txtlong').item(0).firstChild.data;
	var mynode = xmlNode.getElementsByTagName('daytime').item(0);	
	this.daytimeIcon=mynode.getElementsByTagName('wxf').item(0).getAttribute('icon');
	this.daytimeHigh=mynode.getElementsByTagName('wxf').item(0).getAttribute('htmp');
	this.daytimeRealFeelHigh=mynode.getElementsByTagName('wxf').item(0).getAttribute('rfh');
	this.daytimeWindSpeed=mynode.getElementsByTagName('wxf').item(0).getAttribute('wspd');
	this.daytimeWindDirection=mynode.getElementsByTagName('wxf').item(0).getAttribute('wdir');
	this.daytimeWindGust=mynode.getElementsByTagName('wxf').item(0).getAttribute('wgus');
	this.daytimeMaxUV=mynode.getElementsByTagName('wxf').item(0).getAttribute('mxuv');
	this.daytimeRain=mynode.getElementsByTagName('wxf').item(0).getAttribute('rain');
	this.daytimeSnow=mynode.getElementsByTagName('wxf').item(0).getAttribute('snow');
	this.daytimePrecip=mynode.getElementsByTagName('wxf').item(0).getAttribute('prec');
	this.daytimeColor=mynode.getElementsByTagName('wxf').item(0).getAttribute('color');
	this.daytimeGTemp=mynode.getElementsByTagName('wxf').item(0).getAttribute('gtmp');
	this.daytimetColor=mynode.getElementsByTagName('wxf').item(0).getAttribute('color');
	
	//Nighttime forecast data
	//this.nighttimeTextShort=xmlNode.getElementsByTagName('./nighttime/txtshort').item(0).firstChild.data;
	//this.nighttimeTextLong=xmlNode.getElementsByTagName('./nighttime/txtlong').item(0).firstChild.data;
	var mynode = xmlNode.getElementsByTagName('nighttime').item(0);
	this.nighttimeIcon=mynode.getElementsByTagName('wxf').item(0).getAttribute('icon');
	this.nighttimeLow=mynode.getElementsByTagName('wxf').item(0).getAttribute('ltmp');
	this.nighttimeRealFeelLow=mynode.getElementsByTagName('wxf').item(0).getAttribute('rfl');
	this.nighttimeWindSpeed=mynode.getElementsByTagName('wxf').item(0).getAttribute('wspd');
	this.nighttimeWindDirection=mynode.getElementsByTagName('wxf').item(0).getAttribute('wdir');
	this.nighttimeWindGust=mynode.getElementsByTagName('wxf').item(0).getAttribute('wgus');
	this.nighttimeRain=mynode.getElementsByTagName('wxf').item(0).getAttribute('rain');
	this.nighttimeSnow=mynode.getElementsByTagName('wxf').item(0).getAttribute('snow');
	this.nighttimePrecip=mynode.getElementsByTagName('wxf').item(0).getAttribute('prec');
	this.nighttimeColor=mynode.getElementsByTagName('wxf').item(0).getAttribute('color');
	this.nighttimeGTemp=mynode.getElementsByTagName('wxf').item(0).getAttribute('gtmp');
}

function loadData(units) 
{
	if (window.timerInterval != 900000)
		window.timerInterval = 900000; // 15 minutes
	
	metric=1;
	if (units=="english")
		metric=0;

	try {
		xml_request = new XMLHttpRequest();
		xml_request.onload = function(e){parseData(xml_request.responseXML);}
		xml_request.overrideMimeType('text/xml');
		xml_request.open('GET', url + 'weather_data_v2.asp?location=' + zip + '&metric=' + metric, false);
		xml_request.setRequestHeader("Cache-Control", "no-cache");
		xml_request.send(null);
		return xml_request;
	} catch (e) {
		showDataError();
	}
}

function parseData(xmlData) 
{
	//alert(xmlData.getElementsByTagName("local").item(0));
	try {
		CurrentLocation=new Location(xmlData.getElementsByTagName("local").item(0));
		WeatherUnits=new Units(xmlData.getElementsByTagName("units").item(0));
		CurrentConditions=new Conditions(xmlData.getElementsByTagName("currentconditions").item(0));
		CurrentImages=new Images(xmlData.getElementsByTagName("images").item(0));
		CurrentForecasts=new Forecasts(xmlData.getElementsByTagName("forecast").item(0));
		CurrentWatches=new Watches(xmlData.getElementsByTagName("watchwarnareas").item(0));
		CurrentLinks=new Links(xmlData.getElementsByTagName("links").item(0));
		CurrentPop=new AccuPop(xmlData.getElementsByTagName("AccuPOP").item(0));
		CurrentHourly=new Hourly(xmlData.getElementsByTagName("Hourly").item(0));
		CurrentSponsor=new Sponsor(xmlData.getElementsByTagName("sponsor").item(0));
		DataComplete=true;
	} catch (e) {
		alert('pasre error: ' + e)

	}
}

function loadLocations(lookupzip)
{
	try {
		xml_request = new XMLHttpRequest();
		xml_request.onload = function(e){parseLocations(xml_request.responseXML);}
		xml_request.overrideMimeType('text/xml');
		xml_request.open('GET', url+'locate_city.asp?location=' + lookupzip, false);
		xml_request.setRequestHeader("Cache-Control", "no-cache");
		xml_request.send(null);
		return xml_request;
	} catch (e) {
		alert('loc error: ' + e);
	}
}

function parseLocations(xmlData)
{
	try {
		CurrentSearch = new Search(xmlData.getElementsByTagName("citylist").item(0));
		searchComplete = true;
		
	} catch (e) {
		
	}
}

